declare("TOP",TOP or {})
TOP = {}
TOP.player = {}
TOP.UI = {}
TOP.UI.init = {}
TOP.toggle = true 
Licenses = {"C","L","H","T","M"}

function TOP:OnEvent(event, data)
    TOP.UI:print("TOP:"..event)
    if event == "PLAYER_ENTERED_GAME" then
        TOP.UI.init()
    elseif TOP.toggle then 
		if (event == "ENTERING_STATION") then
			TOP.UI.dlg.VISIBLE="NO"
		else
            TOP.UI:show()
			TOP.UI.dlg.VISIBLE="YES"
		end
	end
end

function TOP.UI:print(message)
    if message then
        print('\12700ffaa' .. message ..'\127o')
    end
end

function TOP.player:update()
    --Setup the information for the user to be displayed
    --TOP.UI:print("TOP:Updating Player Data")
    TOP.player.license = {}
    TOP.player.current_xp = {}
    TOP.player.next_xp = {}
    TOP.player.xp_p = {}

    for i = 1,5 do
    	TOP.player.license[i] = GetLicenseLevel(i)
    	TOP.player.current_xp[i], TOP.player.next_xp[i] = GetSkillLevel(i)
    	TOP.player.xp_p[i] =  math.floor((TOP.player.current_xp[i]-GetLicenseRequirement(TOP.player.license[i]))/((TOP.player.next_xp[i]-GetLicenseRequirement(TOP.player.license[i]))/100))
    end
end

function TOP.UI:createLicenseVBox()
	--Get an array of iup.vbox containing license data
    TOP.UI.licenseBox = {}
    TOP.UI.licenseLblTtl = {}
    TOP.UI.licenseLblLvl = {}
    TOP.UI.licenseLblLxp = {}
	for i = 1,5 do
		--Setup Labels to be able to update later
        TOP.UI.licenseLblTtl[i] = iup.label{title = Licenses[i]}
        TOP.UI.licenseLblLvl[i] = iup.label{title = TOP.player.license[i]}
        TOP.UI.licenseLblLxp[i] = iup.label{title = " "..TOP.player.xp_p[i].."% "}
        --Add Labels to the vbox
        TOP.UI.licenseBox[i] = iup.vbox {
								TOP.UI.licenseLblTtl[i],
								TOP.UI.licenseLblLvl[i],
								TOP.UI.licenseLblLxp[i],
								alignment="ACENTER",
							}
	end
end

function TOP.UI:updateLabels()
    TOP.player.update()
    for i = 1,5 do 
        TOP.UI.licenseLblTtl[i].title = Licenses[i]..""
        TOP.UI.licenseLblLvl[i].title = TOP.player.license[i]
        TOP.UI.licenseLblLxp[i].title = TOP.player.xp_p[i].."% "
    end
end

function TOP.UI:createWindow()
    --Refresh the window information to be displayed
    TOP.player.update()
    TOP.UI.dlg = iup.stationsubsubframe {
            iup.hbox {  
                unpack(TOP.UI.licenseBox)
            },
        bgcolor="0 0 0 144 *",
        naturalsize="YES",
        border="NO",
        menubox="NO",
        cy="50",
    }
    TOP.UI.dlg.cx = (getwidth(HUD.cboxlayer)/2)-500
end

function TOP.UI:show()
    if(TOP.UI.dlg == nil) then 
        TOP.UI.init()
    end
    if(iup.GetParent(TOP.UI.dlg) == nil) then
        iup.Append(iup.GetNextChild(HUD.cboxlayer),TOP.UI.dlg)
        TOP.UI.dlg:map()
    end
    TOP.UI.updateLabels()
    TOP.UI.dlg.VISIBLE = "YES"
end

function TOP.UI:toggle()
    TOP.toggle = not TOP.toggle
    if TOP.UI.dlg == nil then
        TOP.UI.init()
    end
    if not TOP.toggle then
        TOP.UI.dlg.VISIBLE = "NO"
        TOP.UI:print("TOP:is now off")
    else 
        TOP.UI.show()
        TOP.UI:print("TOP:is now on")
    end
end

function TOP.UI:init()
        TOP.UI:print("TOP:isLoaded")
        TOP.player.update()
        TOP.UI:createLicenseVBox()
        TOP.UI.createWindow()
end

RegisterEvent(TOP, "PLAYER_ENTERED_GAME")
RegisterEvent(TOP, "ENTERING_STATION")
RegisterEvent(TOP, "HUD_SHOW")
RegisterEvent(TOP, "PLAYER_UPDATE")

RegisterUserCommand("TOP.toggle", function() return TOP.UI:toggle() end)